local timer = require 'hump.timer'()
local canvas
local script
local started = false
local cont_key

function love.load()
  script = love.filesystem.load('yourcode.lua')
  canvas = love.graphics.newCanvas()
  love.graphics.setCanvas(canvas)
  love.graphics.clear(0, 0, 0, 255)
  love.graphics.setCanvas()
  love.graphics.push()
end

local huge = math.huge

function waitkey(cont_key_param)
  cont_key = cont_key_param or true
  sleep(huge)
  cont_key = false
end
-- mouse?
local function resume()
  -- Hack - hump.timer does not expose its resume function, so we
  -- find the time limit in its internal structure and set it to 0
  -- to force the 'after' event to immediately trigger.
  local tmrfunc = next(timer.functions)
  if tmrfunc then
    tmrfunc.limit = 0
  end
end

--
local function timer_script_start(wait_func)
  sleep = wait_func
  script()
end

function love.update(dt)
  love.graphics.setCanvas(canvas)
  love.graphics.pop()
  timer:update(dt)
  if not started then
    started = true
    timer:script(timer_script_start)
  end
  love.graphics.push()
  love.graphics.setCanvas()
end

function love.draw()
  local r,g,b,a = love.graphics.getColor()
  local rgbmode, alphamode = love.graphics.getBlendMode()
  love.graphics.setColor(255, 255, 255, 255)
  love.graphics.setBlendMode("replace", "premultiplied")
  love.graphics.draw(canvas)
  love.graphics.setBlendMode(rgbmode, alphamode)
  love.graphics.setColor(r, g, b, a)
  
	-- info on the screen:  
  if count ~= N*N then	
	love.graphics.print('Press Mouse left', 142, 0) 		-- love screen
	love.graphics.print('Btn to continue.', 142, 14) 		
	--
	love.graphics.print('Chessboard: '..N.." x "..N, 16, 0) 
	love.graphics.print('No of Solutions: '..count, 16, 14) 
  end --if  
end

function love.quit()
  love.graphics.pop()
end
--

function love.keypressed(k)
  if k == "escape" then
    return love.event.quit()
  end
	if cont_key == true or k == cont_key then  
    local tmrfunc = next(timer.functions)
    if tmrfunc then
      tmrfunc.limit = 0
    end
  end
end

function love.mousepressed(x, y, btn)
  if cont_key == true or btn == cont_key then
    resume()
  end
end