-- nQueens continued with pg-contkey

--grafics bg: transparent
local img = love.graphics.newImage('queen-black-40x40.png')

-- ----------------------------------------------------------
-- *** draw chessboard
-- ----------------------------------------------------------
function doCB()
	for i = 1, N do
		for j = 1, N do
			if (i+j)%2 == 0 then  	-- changes color per square
				love.graphics.setColor(255,255,255)	-- white
			else            
				love.graphics.setColor(255,0,0)		-- red
			end 		
			love.graphics.rectangle("fill", i*bs, j*bs, bs, bs) 			
		end --for-j
	end --for-i
end --func
-- ----------------------------------------------------------
-- *** check whether position (n,c) is free from attacks 
-- ----------------------------------------------------------
local function isplaceok (a, n, c)
	for i = 1, n - 1 do         	-- each queen already placed
		if  a[i] == c or     		-- same column?
			a[i] - i == c - n  or   -- same diagonal?
			a[i] + i == c + n  then -- same diagonal?
      		return false
		end
	end
	return true 					-- no attacks, place: ok
end --func
-- ----------------------------------------------------------
-- *** consolle output / show solution 
-- ----------------------------------------------------------
local function printsolution (a)
	count = count +1				-- incr. counter of solutions
	io.write("solution-no.: "..count.."\n")
	for i = 1, N do
		for j = 1, N do
			io.write(a[i] == j and "x" or "-", " ")	
			if (a[i] == j) then
				-- set queen as yellow circle 
				love.graphics.setColor(255,255,0)		-- yellow 		
				--love.graphics.circle( "fill", j * bs + bs/2, i * bs + bs/2, bs/4 )	
				--love.graphics.draw(img, i*bs, j*bs)		-- show dame as picture 
				love.graphics.draw(img, j*bs, i*bs)		-- show dame as picture 
			end --if
		end --for-j
		io.write("\n")
		sleep(0.30) 
	end --for-i
	io.write("Press (any key or) left Mouse Btn. to continue. ".."\n")
	waitkey()
	doCB()
end --func
-- ----------------------------------------------------------
-- *** add to board 'a' all queens from 'n' to 'N'
-- ----------------------------------------------------------
local function addqueen (a, n)
	if n > N then 					--all queens placed
		printsolution(a)
	else
		for c = 1, N do				--try to place n-th queen
			if isplaceok (a, n, c) then
				a[n] = c
				addqueen(a, n+1)
			end
		end
	end
end --func
-- ----------------------------------------------------------
-- *** program run
-- ----------------------------------------------------------
doCB()
addqueen({}, 1)
io.write("no more solutions. ".."\n")		-- consolle
love.graphics.setColor(0,0,0)				-- black
love.graphics.print('No more', 70, 50) 		-- love screen
love.graphics.print('Solutions.', 70, 64) 
-- -------------------------------------------------- pgm end